#include "Mutex.hh"
#include "ThreadError.hh"

#include <iostream>
using namespace std;
Mutex::Mutex() {
	int res=pthread_mutex_init(&mutex_,NULL);
	if(res!=0) {
		throw ThreadError("can't create mutex...");
	}
}

Mutex::~Mutex() {
	int res=pthread_mutex_destroy(&mutex_);
	if(res!=0){
		cerr << "Mutex::~Mutex(): error in destroing mutex..." << endl;
	}
}

void Mutex::lock() {
	int res=pthread_mutex_lock(&mutex_);
	if(res!=0) {
		throw ThreadError("can't lock mutex...");
	}
}

void Mutex::unlock() {
	int res=pthread_mutex_unlock(&mutex_);
	if(res!=0) {
		throw ThreadError("can't unlock mutex...");
	}
}
