#include "Thread.hh"
#include "Guard.hh"
#include "ThreadError.hh"

Thread::Thread() 
	: thread_id_(0),
	  is_started_(false)
{}

Thread::~Thread() {
	// nothing to do...
}

void* Thread::internal_run(void* arg) {
	Thread* thread=static_cast<Thread*>(arg);
	thread->run();
	return NULL;
}

void Thread::start() {
	Guard guard(mutex_);

	if(is_started_){
		throw ThreadError("thread already started...");
	}
	int res=pthread_create(&thread_id_,NULL,
		Thread::internal_run,this);
	if(res!=0) {
		throw ThreadError("can't create thread...");
	}
	is_started_=true;
}

bool Thread::is_started() {
	Guard guard(mutex_);
	return is_started_;
}



